################################################
#           zABBER Popup Menus File            #
################################################
#                                              #
#   This file contains the popups used in      #
#   the roster-tree.                           #
#                                              #
################################################

menu .popup_group -tearoff 0
menu .popup_user -tearoff 0
menu .popup_nick -tearoff 0
menu .popup_group.script -tearoff 0
menu .popup_nick.script -tearoff 0
menu .popup_user.script -tearoff 0

.popup_group add command -label "Send Message" -font "[.popup_group cget -font] bold" \
  -command {
	set a ""; set b ""; set gname [file tail [Tree:getselection .win.f.tree]]
	foreach a $JabberLib(roster,groups,$gname) {set b "$b,$a"}
        set b [string range $b 1 end]
	sendwin ".mes_$gname" $b "" "" "" "" "MESSAGE"
	unset a; unset b; unset gname}
.popup_group add command -label "Send URL" \
  -command {
	set a ""; set b ""; set gname [file tail [Tree:getselection .win.f.tree]]
	foreach a $JabberLib(roster,groups,$gname) {set b "$b,$a"}
        set b [string range $b 1 end]
	sendwin ".mes_$gname" $b "" "" "" "" "URL"
	unset a; unset b; unset gname}
.popup_group add command -label "Send File" -state disabled
.popup_group add separator
.popup_group add command -label "Add New User" -command adduserwin
.popup_group add separator
.popup_group add command -label "Delete User" -state disabled
.popup_group add command -label "Delete Group" -command {zabber:delgroup [file tail [Tree:getselection .win.f.tree]]}
.popup_group add separator
.popup_group add cascade -label "Scripts" -menu .popup_group.script
.popup_group add separator
.popup_group add command -label "Preferences" -command "configwindow"


.popup_user add command -label "Send Message" -font "[.popup_user cget -font] bold" \
  -command {set uname [file tail [Tree:getselection .win.f.tree]]
	    sendwin .mes_$uname $uname "" "" "" "" "MESSAGE"
	    unset uname}
.popup_user add command -label "Send URL" \
  -command {set uname [file tail [Tree:getselection .win.f.tree]]
	    sendwin .mes_$uname $uname "" "" "" "" "URL"
	    unset uname}
.popup_user add command -label "Send File"
.popup_user add separator
.popup_user add command -label "Info" \
  -command {set uname [file tail [Tree:getselection .win.f.tree]]
	    set list $JabberLib(roster,users,$uname)

	    set nname [lindex [lsort -command "zabber:prisort $uname" $list] 0]
	    if {$nname!=""} {
		   set type [lindex $JabberLib(roster,users,$uname,$nname) 0]
		   set msg  [lindex $JabberLib(roster,users,$uname,$nname) 1]
		   set pri  [lindex $JabberLib(roster,users,$uname,$nname) 2]
		   set icon [lindex $JabberLib(roster,users,$uname,$nname) 3]
		} else {
		   set nname "-"
		   set type "-"
		   set msg ""
		   set pri "-"
		   set icon "-"
	    }

	    infowin $uname $nname $type $icon $pri $msg
	    unset list type msg pri icon}

.popup_user add separator
.popup_user add command -label "Add New User" -command adduserwin
.popup_user add separator
.popup_user add command -label "Delete User" -command {zabber:deluser [file tail [set a [Tree:getselection .win.f.tree]]] [lindex [file split $a] 1]}
.popup_user add command -label "Delete Group" -state disabled
.popup_user add separator
.popup_user add cascade -label "Scripts" -menu .popup_user.script
.popup_user add separator
.popup_user add command -label "Preferences" -command "configwindow"


.popup_nick add command -label "Send Message" -font "[.popup_user cget -font] bold" \
  -command {set uname [lindex [file split [Tree:getselection .win.f.tree]] 2]
	    set nname [file tail [Tree:getselection .win.f.tree]]
	    set wname "_$nname"
	    set wname "$uname$wname"

	    sendwin .mes_$wname $uname $nname "" "" "" "MESSAGE"
	    unset uname; unset nname}
.popup_nick add command -label "Send URL" \
  -command {set uname [lindex [file split [Tree:getselection .win.f.tree]] 2]
	    set nname [file tail [Tree:getselection .win.f.tree]]
	    set wname "_$nname"
	    set wname "$uname$wname"

	    sendwin .mes_$wname $uname $nname "" "" "" "URL"
	    unset uname; unset nname}
.popup_nick add command -label "Send File"
.popup_nick add separator
.popup_nick add command -label "Info" \
  -command {set a [file split [Tree:getselection .win.f.tree]]
	    set uname [lindex $a 2]
	    set nname [lindex $a 3]
	    set type [lindex $JabberLib(roster,users,$uname,$nname) 0]
	    set msg  [lindex $JabberLib(roster,users,$uname,$nname) 1]
	    set pri  [lindex $JabberLib(roster,users,$uname,$nname) 2]
	    set icon [lindex $JabberLib(roster,users,$uname,$nname) 3]

	    infowin $uname $nname $type $icon $pri $msg
	    unset a type msg pri icon}
.popup_nick add separator
.popup_nick add command -label "Add New User" -command adduserwin
.popup_nick add separator
.popup_nick add command -label "Delete User" -state disabled
.popup_nick add command -label "Delete Group" -state disabled
.popup_nick add separator
.popup_nick add cascade -label "Scripts" -menu .popup_nick.script
.popup_nick add separator
.popup_nick add command -label "Preferences" -command "configwindow"
