################################################
#          zABBER Window Handle File           #
################################################
#                                              #
#   This file handles all the windows in       #
#   zABBER.                                    #
#                                              #
################################################

proc drawwindow {} {
global jabber

    ###################
    # CREATING WIDGETS
    ###################
    toplevel .win -class toplevel -menu .win.m
    wm transient .win .
    wm focusmodel .win passive
    wm geometry .win $jabber(win,geom_mainwin)
    wm maxsize .win 1028 752
    wm minsize .win 116 1
    wm overrideredirect .win 0
    wm resizable .win 1 1
    wm deiconify .win
    wm title .win "zABBER - Test Version"

    wm protocol .win WM_DELETE_WINDOW {
	save_geom_mainwin
	zabber:disconnect
	exit
	}

    frame .win.f -bd 1 -height 75 -relief sunken -width 125
    Tree:create .win.f.tree -width 1 -height 1 -yscrollcommand "scrolltree2"
    scrollbar .win.f.scr23 -orient vert -command "scrolltree"
    frame .win.secretf -bd 1 -relief sunken
    label .win.secretf.l0 -bd 0 -text ""
    label .win.secretf.l1 -bd 0 -image ""
    label .win.secretf.l2 -bd 0 -text ""
    label .win.secretf.l3 -bd 0 -text ""
    frame .win.f0 -bd 2 -relief groove 
    message .win.f0.mes24 -aspect 5000 -bd 0 -padx 2 -pady 2 -text Status 
    menubutton .win.f0.men25 \
        -activebackground #ffffff -anchor w -background #ffffff \
        -disabledforeground #ffffff -highlightbackground #ffffff \
        -menu .win.f0.men25.m -pady 0 -relief sunken \
        -text Offline
    menu .win.f0.men25.m -tearoff 0
    .win.f0.men25.m add radiobutton -label Online -value online -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {.win.f0.men25 configure -text Online}; JabberLib:change:status "online" $jabber(msgs,$jabber(condition)) [.win.f0.spin get] $jabber(condition)}
    .win.f0.men25.m add radiobutton -label Privacy -value OFFLINE -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {JabberLib:change:status "offline" $JabberLib(status,say) "" ""; .win.f0.men25 configure -text Privacy}}
    .win.f0.men25.m add radiobutton -label Offline -value offline -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="on"} {zabber:disconnect; destroy .adduserwin}}
    message .win.f0.mes26 -bd 0 -padx 5 -pady 2 -text ""
    spinbutton .win.f0.spin -bd 1 -limit {-25 25} -entbackground #ffffff -execute {global JabberLib; JabberLib:change:status "" $JabberLib(status,say) [.win.f0.spin get] ""}

    ###################
    # SETTING VALUES
    ###################
    .win.f0.spin set $jabber(priority)

    
    ###################
    # SETTING MENUS
    ###################
    menu .win.m

    menu .win.m.jabber -tearoff 0
    menu .win.m.roster -tearoff 0
    menu .win.m.jabber.condition -tearoff 0

    .win.m add cascade -label Jabber -underline 0 -menu .win.m.jabber
    .win.m add cascade -label Roster -underline 0 -menu .win.m.roster

    .win.m.jabber add radiobutton -label Online -value online -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {.win.f0.men25 configure -text Online}; JabberLib:change:status "online" $jabber(msgs,$jabber(condition)) [.win.f0.spin get] $jabber(condition)}
    .win.m.jabber add radiobutton -label Privacy -value OFFLINE -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {JabberLib:change:status "offline" $JabberLib(status,say) "" ""; .win.f0.men25 configure -text Privacy}}
    .win.m.jabber add radiobutton -label Offline -value offline -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="on"} {zabber:disconnect; destroy .adduserwin}}

    .win.m.jabber add separator
    .win.m.jabber add cascade -label Condition -menu .win.m.jabber.condition
    .win.m.jabber add separator
    .win.m.jabber add command -label "Preferences" -command configwindow
    .win.m.jabber add separator
    .win.m.jabber add command -label "Exit" -command {save_geom_mainwin; zabber:disconnect; exit}

    .win.m.jabber.condition add radiobutton -label "Happy" -value happy -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "happy"}
    .win.m.jabber.condition add radiobutton -label "Programming" -value programming -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "programming"}
    .win.m.jabber.condition add radiobutton -label "Playing" -value playing -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "playing"}
    .win.m.jabber.condition add radiobutton -label "Eating" -value eating -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "eating"}
    .win.m.jabber.condition add radiobutton -label "Normal" -value normal -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "normal"}
    .win.m.jabber.condition add radiobutton -label "Away" -value away -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "away"}
    .win.m.jabber.condition add radiobutton -label "Sad" -value sad -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "sad"}
    .win.m.jabber.condition add radiobutton -label "Angry" -value angry -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "angry"}

    .win.m.roster add command -label "Add New User" -state disabled -command adduserwin
    .win.m.roster add separator
    .win.m.roster add command -label "Delete Group" -state disabled -command {zabber:delgroup [file tail [Tree:getselection .win.f.tree]]}
    .win.m.roster add command -label "Delete User" -state disabled -command {zabber:deluser [file tail [set a [Tree:getselection .win.f.tree]]] [lindex [file split $a] 1]}
    .win.m.roster add separator
    .win.m.roster add command -label "Reload Roster" -state disabled -command {
	global JabberLib
	foreach group $JabberLib(roster,groups) {Tree:delitem .win.f.tree "/$group"}
	JabberLib:roster:reget
    }

    menu .win.m.system
    .win.m.system add command -label deneme
    ###################
    # SETTING GEOMETRY
    ###################
    pack .win.f -anchor center -expand 1 -fill both -side top 
    pack .win.f.tree -anchor center -expand 1 -fill both -side left 
    pack .win.f.scr23 -anchor center -expand 0 -fill y -side left 
    pack .win.f0 -anchor center -expand 0 -fill x -side top 
    pack .win.f0.mes24 -anchor center -expand 0 -fill none -side left 
    pack .win.f0.men25 -anchor center -expand 1 -pady 1 -fill x -side left 
    pack .win.f0.mes26 -anchor center -expand 0 -fill none -side left 
    pack .win.f0.spin -anchor center -expand 0 -fill none -pady 1 -side left 
    pack .win.secretf.l0 -expand 1 -fill x -side left
    pack .win.secretf.l1 -side left
    pack .win.secretf.l2 -side left
    pack .win.secretf.l3 -expand 1 -fill x -side left
}

proc adduserwin {} {
global JabberLib

    if {[winfo exists .adduserwin]} {
        wm deiconify .adduserwin; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel .adduserwin -class Toplevel
    wm focusmodel .adduserwin passive
    wm geometry .adduserwin 244x133+271+162
    wm minsize .adduserwin 116 100
    wm overrideredirect .adduserwin 0
    wm resizable .adduserwin 1 0
    wm maxsize .adduserwin 1028 133
    wm deiconify .adduserwin
    wm title .adduserwin "Add User"
    frame .adduserwin.f0 -bd 2 -height 1 
    frame .adduserwin.f0.f0 -bd 2 -height 1 
    message .adduserwin.f0.f0.m0 -padx 5 -pady 2 -text "Select Group" -width 138 
    message .adduserwin.f0.f0.m1 -padx 5 -pady 2 -text "User's Loginname\n(name@server)" -width 138 
    frame .adduserwin.f0.f1 -bd 2 -height 1 -width 136 
    combobox .adduserwin.f0.f1.group -width 1 -editable true -value [lindex $JabberLib(roster,groups) 0] -background #ffffff
      foreach a $JabberLib(roster,groups) {.adduserwin.f0.f1.group list insert end $a}
    entry .adduserwin.f0.f1.user -background #ffffff
    frame .adduserwin.f1 -bd 2 -height 1 
    button .adduserwin.f1.okbut -bd 2 -highlightthickness 1 -padx 0 \
        -pady 0 -text OK -width 17 \
        -command {if {[set group [.adduserwin.f0.f1.group get]]!="" && [set user [.adduserwin.f0.f1.user get]]!=""} {
			JabberLib:roster:adduser $group $user
			client:roster:group $group
			client:roster:user $group $user
			destroy .adduserwin
			unset group user}}
    ###################
    # SETTING GEOMETRY
    ###################
    pack .adduserwin.f0 -anchor center -expand 1 -fill both -side top 
    pack .adduserwin.f0.f0 -anchor center -expand 0 -fill y -side left 
    pack .adduserwin.f0.f0.m0 -anchor w -expand 0 -fill none -pady 10 -side top 
    pack .adduserwin.f0.f0.m1 -anchor w -expand 0 -fill none -pady 10 -side top 
    pack .adduserwin.f0.f1 -anchor center -expand 1 -fill both -side left 
    pack .adduserwin.f0.f1.group -anchor center -expand 0 -fill x -padx 3 \
        -pady 10 -side top 
    pack .adduserwin.f0.f1.user -anchor center -expand 0 -fill x -padx 3 \
        -pady 17 -side top 
    pack .adduserwin.f1 -anchor center -expand 1 -fill x -side top
    pack .adduserwin.f1.okbut -anchor center -expand 0 -fill x -padx 3 -side right 
}

proc debugwin {} {
    ###################
    # CREATING WIDGETS
    ###################
    toplevel .debugwin -class Toplevel
    wm focusmodel .debugwin passive
    wm geometry .debugwin 329x201+189+145
    wm maxsize .debugwin 1028 752
    wm minsize .debugwin 116 1
    wm overrideredirect .debugwin 0
    wm resizable .debugwin 1 1
    wm deiconify .debugwin
    wm title .debugwin "Debug Window"
    frame .debugwin.f0 -bd 2 -relief sunken 
    text .debugwin.f0.text -height 1 -relief flat -state disabled -width 1 \
        -yscrollcommand {.debugwin.f0.scroll set} -wrap char -background #ffffff
    scrollbar .debugwin.f0.scroll -command {.debugwin.f0.text yview} -orient vert 
    frame .debugwin.f1 -bd 2 -relief groove 
    message .debugwin.f1.mes -aspect 5000 -bd 0 -padx 5 -pady 2 \
        -text Server: 
    entry .debugwin.f1.entry -width 0 -background #ffffff

    ###################
    # SETTING BINDINGS
    ###################
    bind .debugwin.f1.entry <Control-KeyRelease-Return> {.debugwin.f1.entry insert insert "\x0A"}
    bind .debugwin.f1.entry <KeyRelease-Return> {set a [.debugwin.f1.entry get]
                                                 .debugwin.f1.entry delete 0 end
                                                 .debugwin.f0.text configure -state normal
                                                 .debugwin.f0.text insert end "\nDebugServer: $a"
                                                 .debugwin.f0.text see end
                                                 .debugwin.f0.text configure -state disabled
                                                 XML:parse $a "JabberLib:parse:main"}

    ###################
    # SETTING GEOMETRY
    ###################
    pack .debugwin.f0 -anchor center -expand 1 -fill both -side top 
    pack .debugwin.f0.text -anchor center -expand 1 -fill both -side left 
    pack .debugwin.f0.scroll -anchor center -expand 0 -fill y -side left 
    pack .debugwin.f1 -anchor center -expand 0 -fill x -side top 
    pack .debugwin.f1.mes -anchor center -expand 0 -fill none -side left 
    pack .debugwin.f1.entry -anchor center -expand 1 -fill x -side left 
}

proc errorwin {base subject message} {
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 354x166+170+153
    wm maxsize $base 1028 752
    wm minsize $base 116 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Error"
    frame $base.f0 -bd 2 -height 75 -relief groove -width 125 
    message $base.f0.mes0 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Subject: 
    entry $base.f0.subject -bd 1 -state disabled -width 0 -background #ffffff
    frame $base.f1 -bd 2 -relief sunken 
    text $base.f1.text -height 1 -relief flat -state disabled -width 1 \
        -yscrollcommand "$base.f1.scroll set" -wrap word -background #ffffff
    scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
    frame $base.f2 -bd 2 -relief groove 
    button $base.f2.but33 -bd 1 -highlightthickness 0 -padx 0 \
        -pady 0 -text OK -width 17 -command "destroy $base"
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f0 -anchor center -expand 0 -fill x -ipady 2 -side top 
    pack $base.f0.mes0 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.subject -anchor center -expand 1 -fill x -padx 2 -side left 
    pack $base.f1 -anchor center -expand 1 -fill both -side top 
    pack $base.f1.text -anchor center -expand 1 -fill both -side left 
    pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
    pack $base.f2 -anchor center -expand 0 -fill x -ipadx 2 -ipady 2 -side top 
    pack $base.f2.but33 -anchor center -expand 0 -fill x -padx 3 -side right 
    ###################
    # PUTTING TEXT
    ###################
    $base.f0.subject configure -state normal
    $base.f1.text configure -state normal
    $base.f0.subject insert end $subject
    $base.f1.text insert end $message
    $base.f0.subject configure -state disabled
    $base.f1.text configure -state disabled

}

#
# $stats can be "new" or "next"
#
proc receivewin {from stats} {
global jabber
    set a "meswin_$from"
    set b "_"
    set base ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}
    }
    set base ".$base"

    if {$stats=="new" && [winfo exist $base]!=0} {
	$base.f2.okbut configure -text "Next" -command "receivewin \{$from\} next"
	return
    }

    set abc [lindex $jabber(messages,$from) 0]

    set nick [lindex $abc 0]
    set subject [lindex $abc 1]
    set thread [lindex $abc 2]
    set pri [lindex $abc 3]
    set message [lindex $abc 4]
    set type [lindex $abc 5]

    set a "nickmeswin_$from.$nick"
    set nickbase ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set nickbase "$nickbase$b"} else {set nickbase "$nickbase$ch"}
    }
    set nickbase ".$nickbase"

    set jabber(messages,$from) [lreplace $jabber(messages,$from) 0 0]
    if {[llength $jabber(messages,$from)]==0} {set jabber(messages) [lreplace $jabber(messages) [set a [lsearch $jabber(messages) $from]] $a]}
    unset a b i ch abc

    if {[winfo exists $base]==0} {
	###################
	# CREATING WIDGETS
	###################
	toplevel $base -class Toplevel
	wm focusmodel $base passive
	wm geometry $base $jabber(win,geom_receiwin)
	wm maxsize $base 1028 752
	wm minsize $base 116 1
	wm overrideredirect $base 0
	wm resizable $base 1 1
	wm deiconify $base
	focus $base
	wm protocol $base WM_DELETE_WINDOW "save_geom_receiwin \{$base\}; destroy \{$base\}"

	frame $base.f0 -bd 2 -height 75 -relief groove -width 125 
	frame $base.f0.f0 -bd 2 
	message $base.f0.f0.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text From: 
	entry $base.f0.f0.from -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes21 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Nick: 
	entry $base.f0.f0.nick -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes26 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Thread: 
	entry $base.f0.f0.thread -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes27 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Pri: 
	spinbutton $base.f0.f0.pri -bd 1 -width 5

	frame $base.f0.f1 -bd 2 
	message $base.f0.f1.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Subject: 
	entry $base.f0.f1.subject -bd 1 -width 0 -background #ffffff
	frame $base.f1 -bd 2 -relief sunken 
	text $base.f1.text -height 1 -relief flat -width 1 -yscrollcommand "\{$base.f1.scroll\} set" -background #ffffff
	textbind $base.f1.text
	scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
	frame $base.f2 -bd 2 -relief groove 
	button $base.f2.replybut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\}"
	button $base.f2.forwardbut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Forward -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) {} {} \{$thread\} \{$subject\} \{$message\} \{$type\}"
	button $base.f2.okbut -bd 1 -highlightthickness 0 -padx 0 -pady 0
	###################
	# SETTING GEOMETRY
	###################
	pack $base.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.from -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes26 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes27 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f1.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
	pack $base.f1 -anchor center -expand 1 -fill both -side top 
	pack $base.f1.text -anchor center -expand 1 -fill both -side left 
	pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
	pack $base.f2 -anchor center -expand 0 -fill x -side top 
	pack $base.f2.replybut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.forwardbut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.okbut -anchor center -expand 1 -fill x -padx 2 -side left
    }

    switch -- $type {
	{MESSAGE} {wm title $base "Message Received"
		   $base.f0.f1.mes20 configure -text Subject: 
		   $base.f2.replybut configure -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\} \{MESSAGE\}"}
	{URL}     {wm title $base "URL Received"
		   $base.f0.f1.mes20 configure -text URL: 
		   $base.f2.replybut configure -text Visit -command "linkvisit $subject"}
    }

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.from configure -state normal
    $base.f0.f0.nick configure -state normal
    $base.f0.f0.thread configure -state normal
    $base.f0.f0.pri configure -state normal
    $base.f0.f1.subject configure -state normal
    $base.f1.text configure -state normal

    $base.f0.f0.from delete 0 end
    $base.f0.f0.nick delete 0 end
    $base.f0.f0.thread delete 0 end
    $base.f0.f0.pri set 0
    $base.f0.f1.subject delete 0 end
    $base.f1.text delete 0.0 end

    $base.f0.f0.from insert end $from
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f0.pri set $pri
    $base.f0.f1.subject insert end $subject

    set tx ""
    set url 0
    set a [string tolower $message]
    if {[string match "http://*" $a]} {set url 1}
    if {[string match "ftp://*" $a]} {set url 1}
    if {[string match "mailto:*" $a]} {set url 1}

    for {set i 0} {$i<[string length $message]} {incr i} {
      set char [string index $message $i]

      if {$char==" " || $char=="	" || $char=="\n"} {
        if {$url==1} {
          $base.f1.text insert end $tx URL
          set tx ""
          set url 0
          }
        if {$url==0} {
          set a "[string tolower [string range $message [expr "$i+1"] end]]"
          if {[string match "http://*" $a]} {set url 1}
          if {[string match "ftp://*" $a]} {set url 1}
          if {[string match "mailto:*" $a]} {set url 1}
          if {$url==1} {
            set tx "$tx "; set char ""
            $base.f1.text insert end $tx
            set tx ""
            }
          }
        }
      set tx "$tx$char"
      }
    if {$url=="1"} {$base.f1.text insert end $tx URL} else {$base.f1.text insert end $tx}

    $base.f0.f0.from configure -state disabled
    $base.f0.f0.nick configure -state disabled
    $base.f0.f0.thread configure -state disabled
    $base.f0.f0.pri configure -state disabled
    $base.f0.f1.subject configure -state disabled
    $base.f1.text configure -state disabled

    set found 0
    foreach abc $jabber(messages,$from) {
	if {[lindex $abc 0]==$nick} {set found 1; break}
    }

    if {[winfo exists $nickbase] && !$found} {$nickbase.f2.okbut configure -text "OK" -command "save_geom_receiwin \{$nickbase\}; destroy \{$nickbase\}"}

    if {[llength $jabber(messages,$from)]==0} {
	$base.f2.okbut configure -text "OK" -command "save_geom_receiwin \{$base\}; destroy \{$base\}; catch \{unset \{jabber(messages,$from)\}\}"
    } else {
	$base.f2.okbut configure -text "Next" -command "receivewin \{$from\} next"
    }

}

#
# $stats can be "new" or "next"
#
proc nickreceivewin {from nick stats} {
global jabber
    set a "nickmeswin_$from.$nick"
    set b "_"
    set base ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}
    }
    set base ".$base"

    set a "meswin_$from"
    set topbase ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set topbase "$topbase$b"} else {set topbase "$topbase$ch"}
    }
    unset a b i ch
    set topbase ".$topbase"

    if {$stats=="new" && [winfo exist $base]!=0} {
	$base.f2.okbut configure -text "Next" -command "nickreceivewin \{$from\} \{$nick\} next"
	return
    }

    set index 0
    foreach abc $jabber(messages,$from) {
	if {[lindex $abc 0]==$nick} {break}
	incr index
    }

    set abc [lindex $jabber(messages,$from) $index]

    set subject [lindex $abc 1]
    set thread [lindex $abc 2]
    set pri [lindex $abc 3]
    set message [lindex $abc 4]
    set type [lindex $abc 5]

    unset abc

    set jabber(messages,$from) [lreplace $jabber(messages,$from) $index $index]
    if {[winfo exists $topbase] && $jabber(messages,$from)==""} {$topbase.f2.okbut configure -text "OK" -command "save_geom_receiwin \{$topbase\}; destroy \{$topbase\}; catch \{unset \{jabber(messages,$from)\}\}; "}
    if {[llength $jabber(messages,$from)]==0} {set jabber(messages) [lreplace $jabber(messages) [set a [lsearch $jabber(messages) $from]] $a]}

    if {[winfo exists $base]==0} {
	###################
	# CREATING WIDGETS
	###################
	toplevel $base -class Toplevel
	wm focusmodel $base passive
	wm geometry $base $jabber(win,geom_receiwin)
	wm maxsize $base 1028 752
	wm minsize $base 116 1
	wm overrideredirect $base 0
	wm resizable $base 1 1
	wm deiconify $base
	focus $base
	wm protocol $base WM_DELETE_WINDOW "save_geom_receiwin \{$base\}; destroy \{$base\}"

	frame $base.f0 -bd 2 -height 75 -relief groove -width 125 
	frame $base.f0.f0 -bd 2 
	message $base.f0.f0.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text From: 
	entry $base.f0.f0.from -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes21 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Nick: 
	entry $base.f0.f0.nick -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes26 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Thread: 
	entry $base.f0.f0.thread -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
	message $base.f0.f0.mes27 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Pri: 
	spinbutton $base.f0.f0.pri -bd 1 -width 5

	frame $base.f0.f1 -bd 2 
	message $base.f0.f1.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Subject: 
	entry $base.f0.f1.subject -bd 1 -width 0 -background #ffffff
	frame $base.f1 -bd 2 -relief sunken 
	text $base.f1.text -height 1 -relief flat -width 1 -yscrollcommand "\{$base.f1.scroll\} set" -background #ffffff
	textbind $base.f1.text
	scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
	frame $base.f2 -bd 2 -relief groove 
	button $base.f2.replybut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\}"
	button $base.f2.forwardbut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Forward -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) {} {} \{$thread\} \{$subject\} \{$message\} \{$type\}"
	button $base.f2.okbut -bd 1 -highlightthickness 0 -padx 0 -pady 0
	###################
	# SETTING GEOMETRY
	###################
	pack $base.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.from -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes26 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes27 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f1.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
	pack $base.f1 -anchor center -expand 1 -fill both -side top 
	pack $base.f1.text -anchor center -expand 1 -fill both -side left 
	pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
	pack $base.f2 -anchor center -expand 0 -fill x -side top 
	pack $base.f2.replybut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.forwardbut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.okbut -anchor center -expand 1 -fill x -padx 2 -side left
    }

    switch -- $type {
	{MESSAGE} {wm title $base "Message Received"
		   $base.f0.f1.mes20 configure -text Subject: 
		   $base.f2.replybut configure -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\} \{MESSAGE\}"}
	{URL}     {wm title $base "URL Received"
		   $base.f0.f1.mes20 configure -text URL: 
		   $base.f2.replybut configure -text Visit -command "linkvisit $subject"}
    }

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.from configure -state normal
    $base.f0.f0.nick configure -state normal
    $base.f0.f0.thread configure -state normal
    $base.f0.f0.pri configure -state normal
    $base.f0.f1.subject configure -state normal
    $base.f1.text configure -state normal

    $base.f0.f0.from delete 0 end
    $base.f0.f0.nick delete 0 end
    $base.f0.f0.thread delete 0 end
    $base.f0.f0.pri set 0
    $base.f0.f1.subject delete 0 end
    $base.f1.text delete 0.0 end

    $base.f0.f0.from insert end $from
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f0.pri set $pri
    $base.f0.f1.subject insert end $subject

    set tx ""
    set url 0
    set a [string tolower $message]
    if {[string match "http://*" $a]} {set url 1}
    if {[string match "ftp://*" $a]} {set url 1}
    if {[string match "mailto:*" $a]} {set url 1}

    for {set i 0} {$i<[string length $message]} {incr i} {
      set char [string index $message $i]

      if {$char==" " || $char=="	" || $char=="\n"} {
        if {$url==1} {
          $base.f1.text insert end $tx URL
          set tx ""
          set url 0
          }
        if {$url==0} {
          set a "[string tolower [string range $message [expr "$i+1"] end]]"
          if {[string match "http://*" $a]} {set url 1}
          if {[string match "ftp://*" $a]} {set url 1}
          if {[string match "mailto:*" $a]} {set url 1}
          if {$url==1} {
            set tx "$tx "; set char ""
            $base.f1.text insert end $tx
            set tx ""
            }
          }
        }
      set tx "$tx$char"
      }
    if {$url=="1"} {$base.f1.text insert end $tx URL} else {$base.f1.text insert end $tx}

    $base.f0.f0.from configure -state disabled
    $base.f0.f0.nick configure -state disabled
    $base.f0.f0.thread configure -state disabled
    $base.f0.f0.pri configure -state disabled
    $base.f0.f1.subject configure -state disabled
    $base.f1.text configure -state disabled

    set found 0
    foreach abc $jabber(messages,$from) {
	if {[lindex $abc 0]==$nick} {set found 1; break}
    }

    if {!$found} {
	$base.f2.okbut configure -text "OK" -command "save_geom_receiwin \{$base\}; destroy \{$base\}"
    } else {
	$base.f2.okbut configure -text "Next" -command "nickreceivewin \{$from\} \{$nick\} next"
    }

}

proc secretreceivewin {} {
global jabber
    set base ".sfwin"
    set a "_"

    while {[winfo exists $base]} {set base "$base$a"}

    set abc [lindex $jabber(blinker,toppri) 0]

    set from [lindex $abc 0]
    set nick [lindex $abc 1]
    set subject [lindex $abc 2]
    set thread [lindex $abc 3]
    set pri [lindex $abc 4]
    set message [lindex $abc 5]
    set type [lindex $abc 6]

    set num [lindex $abc 8]

    set abc ""
    lappend abc $nick $subject $thread $pri $message $type "1"

    set jabber(messages,$from) [lreplace $jabber(messages,$from) $num $num $abc]

    unset abc num

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base $jabber(win,geom_receiwin)
    wm maxsize $base 1028 752
    wm minsize $base 116 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    focus $base
    wm protocol $base WM_DELETE_WINDOW "save_geom_receiwin \{$base\}; destroy \{$base\}"

    frame $base.f0 -bd 2 -height 75 -relief groove -width 125 
    frame $base.f0.f0 -bd 2 
    message $base.f0.f0.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text From: 
    entry $base.f0.f0.from -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
    message $base.f0.f0.mes21 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Nick: 
    entry $base.f0.f0.nick -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
    message $base.f0.f0.mes26 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Thread: 
    entry $base.f0.f0.thread -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
    message $base.f0.f0.mes27 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Pri: 
    spinbutton $base.f0.f0.pri -bd 1 -width 5
    frame $base.f0.f1 -bd 2 
    message $base.f0.f1.mes20 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Subject: 
    entry $base.f0.f1.subject -bd 1 -width 0 -background #ffffff
    frame $base.f1 -bd 2 -relief sunken 
    text $base.f1.text -height 1 -relief flat -width 1 -yscrollcommand "\{$base.f1.scroll\} set" -background #ffffff
    textbind $base.f1.text
    scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
    frame $base.f2 -bd 2 -relief groove 
    button $base.f2.replybut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\} \{MESSAGE\}"
    button $base.f2.forwardbut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text Forward -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) {} {} \{$thread\} \{$subject\} \{$message\} \{$type\}"
    button $base.f2.okbut -bd 1 -highlightthickness 0 -padx 0 -pady 0 -text "OK" -command "save_geom_receiwin \{$base\}; destroy \{$base\};"
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0.mes20 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.from -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.mes26 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.mes27 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f1.mes20 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
    pack $base.f1 -anchor center -expand 1 -fill both -side top 
    pack $base.f1.text -anchor center -expand 1 -fill both -side left 
    pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
    pack $base.f2 -anchor center -expand 0 -fill x -side top 
    pack $base.f2.replybut -anchor center -expand 1 -fill x -padx 2 -side left 
    pack $base.f2.forwardbut -anchor center -expand 1 -fill x -padx 2 -side left 
    pack $base.f2.okbut -anchor center -expand 1 -fill x -padx 2 -side left

    switch -- $type {
	{MESSAGE} {wm title $base "Top Priority Message Received"
		   $base.f0.f1.mes20 configure -text Subject: 
		   $base.f2.replybut configure -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\} \{MESSAGE\}"}
	{URL}     {wm title $base "Top Priority URL Received"
		   $base.f0.f1.mes20 configure -text URL: 
		   $base.f2.replybut configure -text Visit -command "linkvisit $subject"}
    }

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.from configure -state normal
    $base.f0.f0.nick configure -state normal
    $base.f0.f0.thread configure -state normal
    $base.f0.f0.pri configure -state normal
    $base.f0.f1.subject configure -state normal
    $base.f1.text configure -state normal

    $base.f0.f0.from delete 0 end
    $base.f0.f0.nick delete 0 end
    $base.f0.f0.thread delete 0 end
    $base.f0.f0.pri set 0
    $base.f0.f1.subject delete 0 end
    $base.f1.text delete 0.0 end

    $base.f0.f0.from insert end $from
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f0.pri set $pri
    $base.f0.f1.subject insert end $subject

    set tx ""
    set url 0
    set a [string tolower $message]
    if {[string match "http://*" $a]} {set url 1}
    if {[string match "ftp://*" $a]} {set url 1}
    if {[string match "mailto:*" $a]} {set url 1}

    for {set i 0} {$i<[string length $message]} {incr i} {
      set char [string index $message $i]

      if {$char==" " || $char=="	" || $char=="\n"} {
        if {$url==1} {
          $base.f1.text insert end $tx URL
          set tx ""
          set url 0
          }
        if {$url==0} {
          set a "[string tolower [string range $message [expr "$i+1"] end]]"
          if {[string match "http://*" $a]} {set url 1}
          if {[string match "ftp://*" $a]} {set url 1}
          if {[string match "mailto:*" $a]} {set url 1}
          if {$url==1} {
            set tx "$tx "; set char ""
            $base.f1.text insert end $tx
            set tx ""
            }
          }
        }
      set tx "$tx$char"
      }
    if {$url=="1"} {$base.f1.text insert end $tx URL} else {$base.f1.text insert end $tx}

    $base.f0.f0.from configure -state disabled
    $base.f0.f0.nick configure -state disabled
    $base.f0.f0.thread configure -state disabled
    $base.f0.f0.pri configure -state disabled
    $base.f0.f1.subject configure -state disabled
    $base.f1.text configure -state disabled

    $base.f2.okbut configure -text "OK" -command "save_geom_receiwin \{$base\}; destroy \{$base\};"
}

#
# $type can be "MESSAGE" or "URL"
#
proc sendwin {base to nick thread subject message type} {
global jabber
    set a "$base"
    set b "_"
    set base ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}
    }
    unset a b i ch
    set base ".$base"

    if {[winfo exists $base]} {
        wm deiconify $base; focus $base; return
    }

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base $jabber(win,geom_sendwin)
    wm maxsize $base 1028 752
    wm minsize $base 116 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    switch -- $type {
	{MESSAGE} {wm title $base "Send Message"}
	{URL}     {wm title $base "Send URL"}
    }
    focus $base

    wm protocol $base WM_DELETE_WINDOW "save_geom_sendwin \{$base\}; destroy \{$base\}"

    frame $base.f0 -bd 2 -height 75 -relief groove -width 125 
    frame $base.f0.f0 -bd 2 
    message $base.f0.f0.01 -aspect 5000 -bd 0 -padx 5 -pady 2 -text To: 
    entry $base.f0.f0.to -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
    message $base.f0.f0.03 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Nick: 
    entry $base.f0.f0.nick -bd 1 -width 1 -background #ffffff
    message $base.f0.f0.mes21 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Thread: 
    entry $base.f0.f0.thread -bd 1 -highlightbackground #c0c0c0 -width 1 -background #ffffff
    message $base.f0.f0.mes22 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Pri: 
    spinbutton $base.f0.f0.pri -bd 1 -width 5
    frame $base.f0.f1 -bd 2 
    switch -- $type {
	{MESSAGE} {message $base.f0.f1.01 -aspect 5000 -bd 0 -padx 5 -pady 2 -text Subject:
		   entry $base.f0.f1.subject -bd 1 -width 0 -background #ffffff}
	{URL}     {message $base.f0.f1.01 -aspect 5000 -bd 0 -padx 5 -pady 2 -text URL:
		   combobox $base.f0.f1.subject -width 1 -value "" -editable 1 -background #ffffff
		   $base.f0.f1.subject list insert end "http://"
		   $base.f0.f1.subject list insert end "ftp://"
		   $base.f0.f1.subject list insert end "mailto:"}
    }

    frame $base.f1 -bd 2 -relief sunken 
    text $base.f1.text -height 1 -relief flat -width 1 \
        -yscrollcommand "\{$base.f1.scroll\} set" -background #ffffff
    scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
    frame $base.f2 -bd 2 -relief groove 

    switch -- $type {
	{MESSAGE} {button $base.f2.sendbut -bd 1 -highlightthickness 0 -padx 0 \
		   -pady 0 -text Send -width 17 -command "zabber:sendmsg \{$base\}; save_geom_sendwin \{$base\}; destroy \{$base\}"}
	{URL}     {button $base.f2.sendbut -bd 1 -highlightthickness 0 -padx 0 \
		   -pady 0 -text Send -width 17 -command "zabber:sendurl \{$base\}; save_geom_sendwin \{$base\}; destroy \{$base\}"}
    }

    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0.01 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.to -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.03 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left
    pack $base.f0.f0.mes22 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f1.01 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
    pack $base.f1 -anchor center -expand 1 -fill both -side top 
    pack $base.f1.text -anchor center -expand 1 -fill both -side left 
    pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
    pack $base.f2 -anchor center -expand 0 -fill x -ipadx 2 -ipady 2 -side top 
    pack $base.f2.sendbut -anchor center -expand 0 -fill x -padx 3 -side right 

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.to insert end $to
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f1.subject insert end $subject
    $base.f1.text insert end $message
}

proc infowin {uname nname status icon pri msg} {
    set a "$uname $nname"
    set b "_"
    set base ""
    for {set i 0} {$i<[string length $a]} {incr i} {
	set ch [string index $a $i]
	if {$ch==" " || $ch=="."} {set base "$base$b"} else {set base "$base$ch"}
    }
    unset a b i ch

    set base ".a$base"

    if {[winfo exists $base]} {
        wm deiconify $base; focus $base; return
    }

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base
    wm focusmodel $base passive
    wm transient $base .
    wm geometry $base 250x250
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "Info about $uname"
    focus $base

    frame $base.f -bd 2 -height 76 -relief groove -width 125
    frame $base.f.f0 -bd 2 -height 1 -width 56
    message $base.f.f0.m0 -aspect 5000 -bd 0 -padx 5 -pady 2 -text {Username :}
    message $base.f.f0.m1 -aspect 5000 -bd 0 -padx 5 -pady 2 -text {Nickname :}
    message $base.f.f0.m2 -aspect 5000 -bd 0 -padx 5 -pady 2 -text {Status :}
    message $base.f.f0.m3 -aspect 5000 -bd 0 -padx 5 -pady 2 -text {Priority :}
    message $base.f.f0.m4 -aspect 5000 -bd 0 -padx 5 -pady 2 -text {Status Message :}
    frame $base.f.f1 -bd 2 -height 1 -width 53
    entry $base.f.f1.e0 -background #c0c0c0 -bd 1 -width 15
    entry $base.f.f1.e1 -background #c0c0c0 -bd 1 -width 15
    entry $base.f.f1.e2 -background #c0c0c0 -bd 1 -width 15
    entry $base.f.f1.e3 -background #c0c0c0 -bd 1 -width 15
    text $base.f.f1.t4 -background #c0c0c0 -height 1 -width 1 -wrap word
    button $base.b -bd 1 -text CLOSE -command "destroy \{$base\}"

    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f -anchor center -expand 1 -fill both -padx 1 -pady 1 -side top
    pack $base.f.f0 -anchor center -expand 0 -fill y -side left
    pack $base.f.f0.m0 -anchor e -expand 0 -fill none -pady 5 -side top
    pack $base.f.f0.m1 -anchor e -expand 0 -fill none -pady 5 -side top
    pack $base.f.f0.m2 -anchor e -expand 0 -fill none -pady 5 -side top
    pack $base.f.f0.m3 -anchor e -expand 0 -fill none -pady 5 -side top
    pack $base.f.f0.m4 -anchor e -expand 0 -fill none -pady 5 -side top
    pack $base.f.f1 -anchor center -expand 1 -fill both -side left
    pack $base.f.f1.e0 -anchor center -expand 0 -fill x -pady 5 -side top
    pack $base.f.f1.e1 -anchor center -expand 0 -fill x -pady 5 -side top
    pack $base.f.f1.e2 -anchor center -expand 0 -fill x -pady 5 -side top
    pack $base.f.f1.e3 -anchor center -expand 0 -fill x -pady 5 -side top
    pack $base.f.f1.t4 -anchor center -expand 1 -fill both -pady 5 -side top
    pack $base.b -anchor center -expand 0 -fill x -padx 2 -pady 2 -side top

    ###################
    # SETTING VALUES
    ###################

    $base.f.f1.e0 insert end "$uname"
    $base.f.f1.e1 insert end "$nname"
    $base.f.f1.e2 insert end "$status / $icon"
    $base.f.f1.e3 insert end "$pri"
    $base.f.f1.t4 insert end "$msg"

    $base.f.f1.e0 configure -state disabled
    $base.f.f1.e1 configure -state disabled
    $base.f.f1.e2 configure -state disabled
    $base.f.f1.e3 configure -state disabled
    $base.f.f1.t4 configure -state disabled
}

proc passwin {} {
global jabber temp cfile

    set temp ""
    set x [expr ([winfo screenwidth .]-250)/2]
    set y [expr ([winfo screenheight .]-132)/2]

    ###################
    # CREATING WIDGETS
    ###################
    toplevel .pass -class toplevel
    wm transient .pass .win
    wm focusmodel .pass passive
    wm geometry .pass 250x132+$x+$y
    wm overrideredirect .pass 0
    wm resizable .pass 0 0
    wm deiconify .pass
    wm title .pass "Account Info"
    wm protocol .pass WM_DELETE_WINDOW {set temp "CANCEL"}
    grab set .pass
    focus .pass

    entry .pass.logname -width 0 -background #ffffff
    entry .pass.servname -width 0 -background #ffffff
    entry .pass.password -width 0 -show "*" -background #ffffff
    entry .pass.nickname -width 0 -background #ffffff
    message .pass.mes1 -text "Username:" -aspect 5000
    message .pass.mes2 -text "Server:" -aspect 5000
    message .pass.mes3 -text "@" -aspect 5000
    message .pass.mes4 -text "Password:" -aspect 5000
    message .pass.mes5 -text "Nickname:" -aspect 5000
    button .pass.b -text "OK" -bd 1 -command {set temp "OK"}

    place .pass.logname -x 5 -y 20 -width 96 -height 19
    place .pass.servname -x 115 -y 20 -width 126 -height 19
    place .pass.password -x 75 -y 50 -width 166 -height 19
    place .pass.nickname -x 75 -y 75 -width 166 -height 19
    place .pass.mes1 -x 0 -y 5 -width 65 -height 11
    place .pass.mes2 -x 110 -y 5 -width 48 -height 11
    place .pass.mes3 -x 100 -y 20 -width 15 -height 21
    place .pass.mes4 -x 0 -y 50
    place .pass.mes5 -x 0 -y 75
    place .pass.b -x 150 -y 105 -width 95 -height 22

    .pass.logname insert 0 $jabber(username)
    .pass.servname insert 0 $jabber(server)
    .pass.password insert 0 $jabber(pass)
    .pass.nickname insert 0 $jabber(nick)

    while {1} {
	tkwait variable temp
	if {$temp=="CANCEL"} {destroy .pass; return "-1"}
	if {[.pass.servname get]==""} {tk_messageBox -parent .pass -title "Error" -message "You must enter a server address!"} \
	  elseif {[.pass.logname get]==""} {tk_messageBox -parent .pass -title "Error" -message "You must enter a login name!"} \
	  elseif {[.pass.password get]==""} {tk_messageBox -parent .pass -title "Error" -message "You must enter a password!"} \
	  else {break}
    }

    set a1 [.pass.servname get]
    set a2 [.pass.logname get]
    set a3 [.pass.password get]
    set a4 [.pass.nickname get]

    if {$a1!=$jabber(server)}   {set jabber(server)   $a1; writeini $cfile server $a1}
    if {$a2!=$jabber(username)} {set jabber(username) $a2; writeini $cfile login  $a2}
    if {$a3!=$jabber(pass)}     {set jabber(pass)     $a3; writeini $cfile pass   $a3}
    if {$a4!=$jabber(nick)}     {set jabber(nick)     $a4; writeini $cfile nick   $a4}

    destroy .pass
}
